image: node:12.16.3

stages:
  - test
  - build
  - deploy

variables:
  MONGODB_VERSION: '4.2.6'
  MONGODB_URL: 'mongodb://mongodb:27017/test'
  PORT: '3002'
  JWT_SECRET: 'test'

# http://docs.gitlab.com/ee/ci/yaml/README.html#cache
cache:
  paths:
    - app/client/node_modules/
    - app/server/node_modules/

test_client:
  stage: test
  script:
    - cd app/client
    - npm install
    - npm run test
    
test_server:
  stage: test
  # Info: http://docs.gitlab.com/ee/ci/docker/using_docker_images.html#what-is-a-service
  services:
    - name: mongo:$MONGODB_VERSION
      alias: mongodb
  script:
    - cd app/server
    - npm install
    - npm run test

